<id>
SeemlySmilie for YaBB 2.7.00
</id>

<version>
1.1
</version>

<mod info>
Description
-----------
Allows admin to assign alternate Smiley sets based on date.

Installation
------------
1) Modify YaBB files using YaBMod.
2) Upload alternate Smiley sets to ModImages/Smilies/smiliefolder (each set must be in its own folder. For 2.7.00 this can now be done from Seemly Smilies View Collections.)
2) Enable Seemly Smilies from Smiley Control Center (You can also enable Seemly Smilie for Message Icons as well.)
3) Set alternate Smiley sets for specific dates in Seemly Smilies Control Center.

Version History
---------------
Written for YaBB SP 1x.
0.1 - Updated for 2.6.0 by Dandello - 29th July, 2014
0.4 - updated for 2.6.1 by Dandello - 05 Sept, 2014
0.5 - updated for 2.6.11 by Dandello - 08 Jan, 2015
0.6 - bug 
0.7 - updated for 2.6.12 by Dandello - 22 Mar, 2016
0.8 - updated for 2.7.00 by Dandello - 22 Mar, 2016
0.9 - updated for 2.7.00 strict by Dandello - 27 Jan, 2017
1.0 - seemly in messages based on message creation/modify date.
1.1 - updated for 2.7.00 Build 2010 - 3 Apr, 2018
</mod info>

<author>
Zoo, updated to 2.7.00 by Dandello
</author>

<homepage>
http://yabbforumsoftware.com
</homepage>

###############################################################################

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $seemlysmilies_mod = q~Seemly Smilies|Zoo, updated for 2.7.00 by Dandello|Admin can set Smiley collections for every day.|1.1|3 Apr, 2018~;
    push @installed_mods, $seemlysmilies_mod;
</add before>

<edit file>
AdminIndex.pl
</edit file>

<search for>
if (@adminindexmods) {
</search for>

<add before>
push @adminindexmods, 'Seemly Smilies';
</add before>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    our %ssmtxt;
    load_language('Mods/Seemly');
    my $seemlysmiliesset_mod = "seemlyset|$ssmtxt{'1'}|$ssmtxt{'1a'}|";
    push @boardmod_mods, $seemlysmiliesset_mod;
</add before>

<edit file>
Admin/Smilies.pm
</edit file>

<search for>
if (@smiliespmmods) {
</search for>

<add before>
push @smiliespmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( %ssmtxt, $enable_seemlysmilie, $enable_seemlymess );
$enable_seemlysmilie ||= q{};
$enable_seemlymess   ||= q{};
load_language('Mods/Seemly');
</add before>

<search for>
                document.getElementsByName("poptext")[0].value = color;
            }
            </script>
        </td>
    </tr><tr>
</search for>

<add after>
        <td class="windowbg2" colspan="4"><label for="enable_seemlysmilie">$ssmtxt{'12'} - <a href="$adminurl?action=seemlyset">$ssmtxt{'1a'}</a></label></td>
        <td class="windowbg2" colspan="4"><input type="checkbox" name="enable_seemlysmilie"${ischecked($enable_seemlysmilie)}></td>
    </tr><tr>
        <td class="windowbg2" colspan="4"><label for="enable_seemlymess">$ssmtxt{'micon'}</label></td>
        <td class="windowbg2" colspan="4"><input type="checkbox" name="enable_seemlymess"${ischecked($enable_seemlymess)}></td>
    </tr><tr>
</add after>

<search for>
    my $count_smimg = $FORM{'smimg_count'};
</search for>

<add after>
    $enable_seemlysmilie = $FORM{'enable_seemlysmilie'} || 0;
    $enable_seemlymess = $FORM{'enable_seemlymess'} || 0;
</add after>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
if (@adminsublistpmmods) {
</search for>

<add before>
push @adminsublistpmmods, 'Seemly Smilies';
</add before>

<search for>
1;
</search for>

<add before>
$director{'seemlyset'} = 'Mods/SeemlySmiliesSet.pm&SeemlySet';
$director{'seemlyset2'} = 'Mods/SeemlySmiliesSet.pm&SeemlySet2';
$director{'seemlyfolder'} = 'Mods/SeemlySmiliesSet.pm&NewSmilieFolder';
$director{'seemlyfolder2'} = 'Mods/SeemlySmiliesSet.pm&NewSmilieFolder2';
$director{'seemlyfolderup'} = 'Mods/SeemlySmiliesSet.pm&NewSmiliesUpload';

</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $enable_seemlysmilie, $enable_seemlymess ); 
</add before>

<search for>
1;
EOF
</search for>

<add before>
\$enable_seemlysmilie = '$enable_seemlysmilie'; #Seemly Smiles Mod
\$enable_seemlymess = '$enable_seemlymess'; #Seemly Smiles Mod
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
if (@englishadminlngmods) {
</search for>

<add before>
push @englishadminlngmods, 'Seemly Smilies';
</add before>

<search for>
1;
</search for>

<add before>
$admin_txt{'uploadedg'} = q~Smilie Uploaded~;

</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
if (@displaypmmods) {
</search for>

<add before>
push @displaypmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $enable_seemlysmilie, $enable_seemlymess );
</add before>

<search for>
        if ( $enable_ubbc && !$ns ) {
            enable_yabbc();
            $message = do_ubbc( $message, q{}, $displayname );
</search for>

<add after>
            my @smiliename = qw(smiley wink cheesy grin angry sad shocked cool huh rolleyes tongue embarassed lipsrsealed undecided kiss cry);
            if ( $enable_seemlysmilie && $enable_seemlymess ) {
                my $smiledir = qq~$yyhtml_root/Smilies~;
                require Sources::Mods::SeemlySmilies;
                my $newsmiledir = seemlyview($messagedate);
                foreach my $i (@smiliename ) {
                    if ($micon{$i}) {
                        $micon{$i} =~ s/$smiledir/$newsmiledir/xsm;
                    }
                }
            }
            $message = getseemlyview($message, $messagedate);
</add after>

<edit file>
Sources/EventCal.pm
</edit file>

<search for>
if (@eventcalpmmods) {
</search for>

<add before>
push @eventcalpmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($enable_seemlysmilie);
</add before>

<search for>
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $dd_year, $dd_mon, $dd_day ) = ( $1, $2, $3 );
</search for>

<replace>
        my ($dd_date);
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $dd_year, $dd_mon, $dd_day ) = ( $1, $2, $3 );
            $dd_date = timegm( 0, 0, 0, $dd_day, $dd_mon-1, $dd_year-1900 );
</replace>

<search for>
        if (   $INFO{'eventdate'}
            && $INFO{'eventdate'} == $cdat
            && !$INFO{'edit_cal_even'} )
        {
</search for>

<add before>
                if ($enable_seemlysmilie) {
                    require Sources::Mods::SeemlySmilies;
                    $message = getseemlyview($message, $dd_date);
                }
</add before>

<search for>
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $da_year, $da_mon, $da_day ) = ( $1, $2, $3 );
</search for>

<replace>
        my ($dadate);
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $da_year, $da_mon, $da_day ) = ( $1, $2, $3 );
            $dadate = timegm( 0, 0, 0, $da_day, $da_mon-1, $da_year-1900 );
</replace>

<search for>
        if (   $event_id eq $ctim
            && $INFO{'eventdate'}
            && $cdat == $INFO{'eventdate'} )
        {
</search for>

<add before>
        if ($enable_seemlysmilie) {
            require Sources::Mods::SeemlySmilies;
            $message = getseemlyview($message, $dadate);
        }
</add before>

<search for>
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $cyear, $cmon, $cday ) = ( $1, $2, $3 );
</search for>

<replace>
        my ($cc_date);
        if ( $cdat =~ /(\d{4})(\d{2})(\d{2})/xsm ) {
            my ( $cyear, $cmon, $cday ) = ( $1, $2, $3 );
            $cc_date = timegm( 0, 0, 0, $cday, $cmon-1, $cyear-1900 );
</replace>

<search for>
                $cevent = do_ubbc( $cevent, q{}, $displayname );
            }
</search for>

<add before>
                if ($enable_seemlysmilie) {
                    require Sources::Mods::SeemlySmilies;
                    $cevent = getseemlyview($cevent, $cc_date);
                }
</add before>

<edit file>
Sources/InstantMessage.pm
</edit file>

<search for>
if (@instantmessagepmmods) {
</search for>

<add before>
push @instantmessagepmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($enable_seemlysmilie);
</add before>

<search for>
    if ( $enable_ubbc && !$nscheck ) {
        enable_yabbc();
        my $displayname = ${ $uid . $messlst{'musername'} }{'realname'};
        if ( $messlst{'mstatus'} eq 'g' || $messlst{'mstatus'} eq 'ga' ) {
            ( $guest_name, $guest_email ) = split /[ ]/xsm,
              $messlst{'musername'};
            $guest_name =~ s/%20/ /gxsm;
            $displayname = $guest_name;
        }
        $message = do_ubbc( $message, q{}, $displayname );
</search for>

<add after>
        if ($enable_seemlysmilie) {
            require Sources::Mods::SeemlySmilies;
            $message = getseemlyview($message, $messlst{'mdate'});
        }
</add after>

<search for>
    if ( $enable_ubbc && !$nscheck ) {
        enable_yabbc();
        my $displayname = ${ $uid . $messlst{'musername'} }{'realname'};
        $messlst{'immessage'} =
          do_ubbc( $messlst{'immessage'}, q{}, $displayname );
</search for>

<add after>
        if ($enable_seemlysmilie) {
            require Sources::Mods::SeemlySmilies;
            $message = getseemlyview($message, $messlst{'mdate'});
        }
</add after>

<edit file>
Sources/MessageIndex.pm
</edit file>

<search for>
if (@messageindexpmmods) {
</search for>

<add before>
push @messageindexpmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $enable_seemlysmilie, $enable_seemlymess );
</add before>

<search for>
        $mydate = timeformat($mdate);
</search for>

<add before>
        my @smiliename = qw(smiley wink cheesy grin angry sad shocked cool huh rolleyes tongue embarassed lipsrsealed undecided kiss cry);
        if ( $enable_seemlysmilie && $enable_seemlymess ) {
            my $smiledir = qq~$yyhtml_root/Smilies~;
            require Sources::Mods::SeemlySmilies;
            my $newsmiledir = seemlyview($mdate);
            foreach my $i (@smiliename ) {
                if ($micon eq $micon{$i}) {
                    $micon =~ s/$smiledir/$newsmiledir/xsm;
                }
            }
        }
</add before>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
if (@mycenterpmmods) {
</search for>

<add before>
push @mycenterpmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($enable_seemlysmilie);
</add before>

<search for>
                    $immessage = make_smileys($immessage);
</search for>

<add after>
                    if ($enable_seemlysmilie) {
                        require Sources::Mods::SeemlySmilies;
                        $immessage = getseemlyview($immessage, $messlst{'mdate'});
                    }
</add after>

<edit file>
Sources/YaBBC.pm
</edit file>

<search for>
if (@yabbcpmmods) {
</search for>

<add before>
push @yabbcpmmods, 'Seemly Smilies';
</add before>

<search for>
    $message =~
s/(\W|^)\[smil(ie|ey)=(\S+?[.](gif|jpg|png|bmp))\]/$1<img class="smil" data-rel="\[smil$2=$3\]" src="$smiledir\/$3" alt="$post_txt{'287'}" title="$smileydesc" \/>/igxsm;
</search for>

<replace>
    my $smiledira = qq~$yyhtml_root/Smilies~;
    our ($enable_seemlysmilie); 
    if ( $enable_seemlysmilie ) { 
        require Sources::Mods::SeemlySmilies;
        $smiledir = seemlyview(time());
    }

    $message =~
s/(\W|^)\[smil(ie|ey)=(\S+?[.](gif|jpg|png|bmp))\]/$1<img class="smil" data-rel="\[smil$2=$3\]" src="$smiledira\/$3" alt="$post_txt{'287'}" title="$smileydesc" \/>/igxsm;
</replace>

<edit file>
Sources/PostBox.pm
</edit file>

<search for>
if (@postboxpmmods) {
</search for>

<add before>
push @postboxpmmods, 'Seemly Smilies';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $enable_seemlysmilie, $enable_seemlymess, $seemlydir );
</add before>

<search for>
        $smilies_list .=
qq~<img src='$yyhtml_root/Smilies/$img' onclick='$click' $hand alt='$alt' title='$alt' />\n~;
</search for>

<replace>

        my $smiledir = qq~$yyhtml_root/Smilies~;
        if ( $enable_seemlysmilie ) {
            require Sources::Mods::SeemlySmilies;
            $smiledir = seemlyview($date);
        }
        $smilies_list .=
qq~<img src='$smiledir/$img' onclick='$click' $hand alt='$alt' title='$alt' />\n~;
</replace>

<edit file>
Templates/default/Micon.def
</edit file>

<search for>
if (@defaultmicondefmods) {
</search for>

<add before>
push @defaultmicondefmods, 'Seemly Smilies';
</add before>

<search for>
my @miconbglist =
  qw(admin_move admin_rem alert announcement announcementlock boardrss buddylist confidential email exclamation hide hidelock hidesticky hidestickylock hotthread ip lamp locked locked_moved lockmail new_mess noimg paperclip poll_mod question rss standard sticky stickylock tabsave thread urgent veryhotthread www xx );
</search for>

<add before>
my @smiliename =
  qw(smiley wink cheesy grin angry sad shocked cool huh rolleyes tongue embarassed lipsrsealed undecided kiss cry);
if ( $enable_seemlysmilie && $enable_seemlymess ) {
    require Sources::Mods::SeemlySmilies;
    my $newsmiledir = seemlyview(time());
    foreach my $i (@smiliename ) {
        if ($micon_bg{$i}) {
            $micon_bg{$i} =~ s/$smiledir/$newsmiledir/xsm;
        }
        if ($micon{$i}) {
            $micon{$i} =~ s/$smiledir/$newsmiledir/xsm;
        }
    }
}

</add before>